#ifndef WIDGET_H
#define WIDGET_H

#include "qgroupbox.h"
#include <QWidget>

class QPushButton;
class QTextBrowser;
class QComboBox;
class QLineEdit;
class ModuleCommunication;

class Widget : public QWidget {
    Q_OBJECT
public:
    explicit Widget(QWidget *parent = nullptr);
    void initializeLogger();

protected:
    QGroupBox *initializeCommandGroupBox();
    void onSerialConnectButtonClicked();
    void onSerialRefreshButtonClicked();

    void onEnrollButtonClicked();
    void onVerifyButtonClicked();
    void onDeleteAllButtonClicked();
    void onDeleteButtonClicked();

    QGroupBox *initializeEnrollGroupBox();
    QGroupBox *initializeVerifyGroupBox();
    QGroupBox *initializeDeleteGroupBox();
    QGroupBox *initializePalmFeatureGroupBox();

private:
    QComboBox *m_serialComboBox = nullptr;
    QPushButton *m_serialConnectButton = nullptr;
    QTextBrowser *m_logBrowser = nullptr;
    QGroupBox *m_commandGroupBox = nullptr;

    QLineEdit *m_enrollNameEdit = nullptr;
    QLineEdit *m_enrollTimeoutEdit = nullptr;
    QPushButton *m_enrollButton = nullptr;

    QLineEdit *m_verifyTimeoutEdit = nullptr;
    QPushButton *m_verifyButton = nullptr;

    QLineEdit *m_deleteIdEdit = nullptr;
    QPushButton *m_deleteButton = nullptr;
    QPushButton *m_deleteAllButton = nullptr;

    std::shared_ptr<ModuleCommunication> m_communication;
};

#endif // WIDGET_H
